import * as wjcCore from 'wijmo/wijmo';
import * as wjcGrid from 'wijmo/wijmo.grid';
import * as wjcGridFilter from 'wijmo/wijmo.grid.filter';
import * as wjcInput from 'wijmo/wijmo.input';

// Angular
import { Component, EventEmitter, Input, Inject, enableProdMode, NgModule, ViewChild, TemplateRef, ElementRef } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { BrowserModule } from '@angular/platform-browser';
import { WjGridModule } from 'wijmo/wijmo.angular2.grid';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
import { WjGridFilterModule } from 'wijmo/wijmo.angular2.grid.filter';
import { ServerCollectionView } from './components/ServerCollectionView';

'use strict';

// The application root component.
@Component({
    selector: 'app-cmp',
    templateUrl: 'src/app.html',
})

export class AppCmp {
    view: ServerCollectionView;

    @ViewChild('grid') grid: wjcGrid.FlexGrid;
    @ViewChild('filter') filter: wjcGridFilter.FlexGridFilter;
    listNames = [];
    loaded = false;

    constructor() {
        var self = this;
        this.view = new ServerCollectionView('DataHandler.ashx', {
            pageOnServer: false,
            pageSize: 10,
            loaded: function (s, e) {

                if (self.loaded) {
                    return;
                }
                
                //self.view.pageSize = 10;
                self.view.pageOnServer = true;

                self.grid.columns.forEach(col => {
                    var f = self.filter.getColumnFilter(col, true);
                    f.valueFilter.uniqueValues = self.getUniqueValues(self.view, col);
                });
                
                self.loaded = true;
            }
        });

    }

    getUniqueValues(view: ServerCollectionView, col: wjcGrid.Column): any[] {
        var list = []
        view.sourceCollection.forEach((item) => {
            if (list.indexOf(item[col.binding]) == -1) {
                list.push(item[col.binding]);
            }
        });
        return list;
    }

    initGrid(grid: wjcGrid.FlexGrid) {

    }
    
}

@NgModule({
    imports: [WjInputModule, WjGridModule, WjGridFilterModule, BrowserModule, FormsModule],
    declarations: [AppCmp],
    bootstrap: [AppCmp]
})
export class AppModule {
}


enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
